var SG = window.SG || {};

SG.Set = {
	init: function(){

		this.container		= $('section').eq(0);
		this.header			= $('header div, hgroup');
		
		this.user			= this.getURLParameter('user')

		this.constrainX		= $(window).width();
		this.colWidth 		= 192;
		this.gutter    		= 9;
		
		this.rpcIndex  		= 0;
		this.rpcIncrement 	= 20;

		this.contentTypes	= 'Video, Blog, Article, Gallery'
		
		this.duration		= 100;
		
		this.placedClips = [];
		$(window).scrollTop(0);
		this.fetch();
//		this.place();	
		this.bind();
	},
	resize : function(){
		var _this = this;
		this.container.children().css({'opacity': 0});
		$(window).resize(function() {
		//	_this.container.css('visibility', 'hidden');	
			if ($(window).width() < _this.container.width() + 4 || $(window).width() > _this.container.width() + _this.colWidth + _this.gutter+ 4){
				setTimeout('SG.Set.place(0, "resize")', 5);
				_this.unplace();
			//	_this.place();
				$(this).unbind('resize');
			}
			
  			//_this.container.children().remove();
		});
		
	},

	collapse : function(target, left){
		var duration = this.duration;
			
		target.css({'min-height': 0, zIndex: 1})
				.animate({
					    width: 192,
    					fontSize: '1.1em',
    					zIndex: 1,
    					borderColor: '#222',
    					marginLeft: 0
				}, duration, 'swing', function(){target.removeClass('selected');});
				target.find('img').animate({marginLeft: left}, duration, 'swing');
	},

	expand: function(target){

			duration 	= this.duration;
			var left	= -64,
				imgLeft = -57;
			if (target.hasClass('left')){
				left 	= 0;
				imgLeft = 0;
			}
			else if (target.hasClass('right')) {
				left 	= -114;
				imgLeft = -114;
			}
	
			target.css({'height': target.height(), zIndex: 8})
				.animate({
					    width: 305,
    					fontSize: '1.2em',

    					borderColor: '#2E6D9D',
    					marginLeft: left
				}, duration, 'swing');
			
			target.find('img').animate({marginLeft: 0}, duration, 'swing')
			
			target.addClass('selected');
			return imgLeft;
	},
	getURLParameter: function (name) {
    	return decodeURI(
        	(RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]
    	);
	},
	bind: function(){
		var _this = this;
		this.resize();
		$(window).scroll(function(e){

		
			//var scrollUnit = $(document).height() - ($(this).height() * (1 + (($(this).scrollTop() / $(document).height() * 2))));
			if($(this).scrollTop() + $(this).height() >= $(document).height() * .95  && _this.container.children().length < 500){
			//	$(this).scrollTop($(this).scrollTop() - (scrollUnit * .3) )
				if (_this.container.data('loading') === true){return}
				_this.scrollTop = $(this).scrollTop();
				_this.fetch();
				
			};
		});
		$(document).delegate('div.clip', 'click', function(e){
			e.preventDefault();
			var target = $(this),
				imgLeft = _this.expand(target);
			$(document).one('click', function(){
				target.unbind('click');
				_this.collapse(target, imgLeft);
			});
			target.one('click', function(e){
				window.location = $(this).find('a').attr('href');
			});
		});

	},
	unplace: function(){
		var temp = $('<section />');
		this.container.children()
			.css({'position': 'static', top: 'auto', left: 'auto'})
			.removeClass('left')
			.removeClass('right')
			.removeClass('selected');
			
			// .appendTo(temp)
			// .end().remove();
			// $(document).prepend(temp);
		this.placedClips = [];
	},
	place: function(startAt, callback){
		console.log('placing: '+ startAt)
		this.constrainX	= $(window).width();
		//var temp 		= $('<div/>'),
		var temp 		= this.container,
			width		= this.colWidth,
			gutter		= this.gutter,
			constrainX	= this.constrainX,
			startAt     = (startAt) ? startAt : 0,
			colCount 	= Math.floor((constrainX + gutter) / (width + gutter)),
			_this 		= this,
			containerWidth, docHeight;
		if (colCount < 3){
			$('h2').eq(0).css('font-size', '5em');
		}
		else{
			$('h2').eq(0).css('font-size', '6.7em');
		}

		$.each(temp.children(), function(i, el){
		   	if (i < startAt) {return};
			var column	= i % colCount,
				posLeft	= column * (width + gutter),
				posTop  = ((i + 1 > colCount) ? function(){
								var clipAbove = (_this.placedClips[i - colCount]);
								return clipAbove.top  + clipAbove.height + gutter;
							}():0);;
				if (column === 0){$(el).addClass('left')}
				else if(column === colCount-1){$(el).addClass('right')}
				$(el).css({'position': 'absolute','top': posTop, 'left': posLeft});
				$(el).animate({'opacity': 1})
				_this.placedClips.push({'top': posTop,  'height': $(el).height()});
		});
		_this.container.data('loading', false);
		// this.container.children().remove();
		// this.container.append(temp.children());
		//$(window).scrollTop(this.scrollTop);
		containerWidth = (colCount * (width + gutter)) - gutter;
		this.container.css('width', containerWidth + 'px');
		this.header.css('width', containerWidth + 'px');
		if (callback){
			this[callback]();
		}
	},
	
	fetch: function(count){
		
		if (this.container.data('loading') === true){
			return;
		}
		
		this.container.data('loading', true);
		
		var _this		= this,
//			count 		= (count) ? count : 50,
			temp 		= $('<div/>'),
			urlBase     = urlBase = 'http://www.washingtonpost.com/rf/image_296w/';

		// for (i = 0; i < count; i++){
		// 	var height	= 160 + Math.floor (Math.random() * 360);
		// 		clip    = $('<div class="clip" style="height: '+height+'px" />');
		// 		temp.append(clip);
		// }
		
		//var URI = 'http://testapp12b:9001/search-recommendation/recommend.jsonp?wpniuser='+this.user+'&types='+this.contentTypes+'&startat='+this.rpcIndex+'&count='+this.rpcIncrement+'&callback=?';
		$.getJSON('http://beta.washingtonpost.com/search-recommendation/videos-test.jsonp?url=http://www.washingtonpost.com/blogs/capitals-insider/post/washington-capitals-season-review-forwards-part-ii/2012/05/25/gJQAUh15pU_blog.html&_=1337978061793&count=25&callback=?', 
		//$.getJSON(URI,	
			function(data){
				var start_at	= _this.container.children().length,
					imgTotal    = 0,
					imgLoaded   = 0;
				_this.rpcIndex += _this.rpcIncrement;
				
				$.each(data.results, function(i, el){
					if (el.url && el.headline){
						var item = $('<div class="clip" style="opacity: 0;">\
								'+((el.photo && el.photo.path) ?
										'<a href="'+el.url+'">\
											<span class="wrapper">\
												<img src="'+ urlBase + el.photo.path + '" alt="'+el.headline+'" title="'+el.contenttype+'" />'
												+((el.contenttype === 'Video') ? '<span class="btn-play"></span>' : '')+
											'</span>\
										</a>':
										'<a href="'+el.url+'" style><img src="assets/img/'+((el.contenttype && el.contenttype !== undefined && el.contenttype !== "Video")?el.contenttype:'Article')+'.png" width="296" /></a>')
										//'<a href="'+el.url+'" style><img src="assets/img/'+el.contenttype+'.png" width="296" /></a>')
								 	// END IF
									+'<h3><a href="'+el.url+'">'+el.headline+'</a></h3>\
									<p>'+el.blurb+'</p>\
								</div>');
						item.fadeOut();
						temp.append(item);
					}
				});

				imgTotal = temp.find('img').length
				_this.container.append(temp.children());
				_this.container.find('img').load(
					function(){
						imgLoaded++;

						//console.log('load one')
						if (imgLoaded === imgTotal){
				//			console.log('load alll')
							_this.place(start_at);
						}
					}
				)
				.error(function(){
			// 		imgLoaded++;
			// 		if (imgLoaded === imgTotal){
			// //			console.log('load alll')
			// 			_this.place(start_at);
			// 		}
					$(this).attr('src', 'assets/img/'+$(this).attr('title')+'.png');
				});
				

		});
	}
};
//$(window).ready
$(function(){SG.Set.init();});