$.extend(SG.Set, {
	Interaction:{
		util:{
			showShim: function(target, imgLeft, duration){	
				this.shim
				.css('display', 'block')
					.data('activeClip', ((target)?target: false))
					.animate(
						{opacity: 0.5},
						 duration, 
						'swing');

			},
			hideShim: function(){
				var shim = this.shim;
				shim
					.animate({opacity: 0}, 500, 'linear', function(){
						shim.css('display', 'none')
					});
			},
			closeWindow: function(){
				var target = this.shim;		
				$(target).addClass('open');	
				var activeClip = $(target).data('activeClip');
				this.hideShim();
				if (!activeClip){
					return;
				}
				else if (activeClip[0] && typeof(activeClip[0]) === 'function'){
					activeClip[0](activeClip[1]);
				}
				else {
					SG.Set.collapse(activeClip[0], activeClip[1]);
				}
			},
			closeWindowFocus: function(){
				this.btn.all.filter('.close').addClass('active');
			},
			closeWindowBlur: function(){
				this.btn.all.filter('.close').removeClass('active');
			}
		},
		scroll:{
			aboveHeader: function(){
				this.container.data('msgTop', true);
				this.msg.top.slideDown(500);
			},
			belowHeader: function(){
				this.container.data('msgTop', false);
				this.msg.top.slideUp(500);
			},
			pagedown: function(){
				if (this.container.data('loading') === true)
					{return}
					
				scrollTop = $(window).scrollTop();
				SG.Set.fetch();
			} 
		},
		dialog: {
			signin : function() {
				var	Display  		= this.Display,
					ui 				= this.Template.dialog(),
					container 		= this.container,
					iframe			= $('<iframe width="100%" height="100%" frameborder="0" scrolling="no" class="content-wrapper"></iframe>'),
					sgAppLocation	= (document.domain) ? document.location : 'http://beta.washingtonpost.com/wp-srv/smartgrid',
					serviceLocation = 'https://id.washingtonpost.com/identity/public/login/options?next_url=' + encodeURIComponent(sgAppLocation);
					
				iframe
					.attr('src', serviceLocation)
					.prependTo(ui);

				ui.appendTo($('body'));
				
				$(window).bind('resize', function(){Display.center(ui)});
				this.util.showShim(ui);
				this.Display.center(ui);
			},
			loading: function(){
				var Display 	= this.Display,
					container 	= this.container,
					msg         = this.msg;

				if (container.data('loading') !== true)
					{return;}
				container.data('msgLoad', true)
					.data('loading', true);
				Display.center(msg.load).fadeIn(500);	
				this.util.showShim(msg.load);
			},
			loadSuccess: function(){
				var container 	= this.container,
					msg         = this.msg;

				if (container.data('msgLoad') !== true){return;}
				container.data('msgLoad', false)
					.data('loading', false);
				msg.load.fadeOut(500);
				msg.fail.stop().fadeOut(500);
				this.util.hideShim();

			},
			loadFail: function(){
				var msg = this.msg;
				this.Display.center(msg.fail).stop().fadeIn(500).delay(2000).fadeOut(500, function(){
					this.util.hideShim();
				});
			}
		},
		newsclip:{
			adLoad : function(e){
				var iframe	= $(e.target),
					wrapper = iframe.contents().find('#slug_flex_ss_bb_hp'),
					width   = wrapper.width(),
					height  = wrapper.height()
					colWidth = this.colWidth;

				iframe
					.height(height)
					.width(width);

				iframe.contents().find('body')
					.height(height)
					.width(width);
				
				iframe.closest('div.clip').width(iframe.closest('div.clip').width() +24)
							.find('a').eq(0).width(iframe.closest('div.clip').width() -10);

				iframe.closest('div.clip').data('fullWidth', iframe.width());

			},
			allLoad : function(){
			
				var container = this.container,
					header	  = this.header
					gutter 	  = this.gutter;

				container
					.isotope('reLayout')
					.data("loading", false)	
					.triggerHandler({type: 'fetch.close'});
					
				this.Display.fitToScreen(SG.Set.colCount);
				$.each(container.children(), function(i, el){
					try{	
			
						var img = $(el).find('iframe, img').first(),
							imgWidth = img.width(),
							width = $(el).width();
									
						if ($(el).data('isotope-item-position').x === 0){
							$(el).addClass('left');
							img.css('margin-left', '0');
						}
						else if ($(el).data('isotope-item-position').x  > (SG.Set.colCount -1) * (SG.Set.colWidth + SG.Set.gutter)){
							$(el).addClass('right');
							img.css('margin-left', 0 - (imgWidth - width + gutter)+'px');
						}
						else{
							img.css('margin-left', 0 - ((imgWidth - width +gutter) / 2) +'px');
						}

					}catch(e){}
				});
				header.width(container.width());
				
			}
			
		},
		photogallery:{ 
			pause: function(target) {
				this.contentFrame  = target.find('.content-frame').eq(0);
				var contentFrame   = this.contentFrame,
					img 		   = contentFrame.find('img').eq(0);
				this.img = img;
				this.ui.photogallery.filter('.pause').css('display', 'none');
				this.ui.photogallery.filter('.play').css('display', 'block');
				this.contentFrame.stop();
				img.css('width', 'auto');
				img.css('height', 'auto');
				if (img.height() < contentFrame.height()){
					img.height(contentFrame.height());
					
					img.css('margin-left', (.5 * (target.width() - img.width())));
				}
				else{
					img.width(contentFrame.width());
					
					img.css('margin-top', (.5 * (target.height() - img.height())));
					
				}
			},
			play: function(target) {
				this.contentFrame.find('a.next').click();	
			},
			imgLoad: function(target, caption, txt){
				
				this.ui.photogallery.filter('.pause').css('display', 'block');
				this.ui.photogallery.filter('.play').css('display', 'none');
				
				var target 			= target,
					contentFrame 	= $('.content-frame'),
					contentWrapper  = $('.content-wrapper'),
					btns			= contentFrame.find('a'),
					slideshowSpeed  = this.slideshowSpeed;
				
				target.css('margin', '0px');
				
				$('.content-frame')
						.scrollLeft(0)
						.next()
							.delay(1000)
							.fadeIn(1000);
				idx = parseInt(target.attr('idx'));

				if (idx === 0){
					btns.eq(1).show(1000);
				}
				else if (btns.eq(0).hide){
					btns.eq(0).show(1000);
				}
	

				
				target.css('height','auto').css('width', contentWrapper.eq(0).innerWidth());

				if (target.height() < contentFrame.height()){	
						contentFrame
							.scrollTop(0)
						
					target.css({'height':contentFrame.height(), width: 'auto'});
					
					contentFrame
						.stop()
						.scrollLeft(0)
						.animate({opacity:1}, 1000, 'linear', function(){
							
							contentFrame
								.animate({'scrollLeft': target.width() - contentFrame.width()}, slideshowSpeed, 'linear', function(){
									contentFrame
										.find('a').eq(1).click();
								});
						});
				}
				else{
						contentFrame
							.scrollTop(0)
							.animate({opacity:1}, 1000, 'linear', function(){
								contentFrame
									.animate({scrollTop: contentWrapper.height() - contentFrame.height()}, slideshowSpeed, 'linear', function(){
										contentFrame.stop()
											.find('a').eq(1).click();

									});
							});
				}
			
			},
			prevnext: function(target, e){
				e.preventDefault();
					var container	= target.parent(),
						img			= container.find('img'),
						caption		= container.parent().find('caption'),
						data		= container.data('binurl'),
						idx			= img.attr('idx') ? parseInt(img.attr('idx')) : 0;

				target.stop();
				target
					.parent()
					.next()
					.fadeOut(500)

				$('.content-frame').stop().animate({opacity:0}, 500, 'linear', function(){
					target.scrollLeft(0);
					if (target.hasClass('prev') && idx > 0){
						img.attr('src', data[idx - 1].src);
						caption.text(data[idx-1].caption);
						img.attr('idx', idx - 1);
						if (img.attr('idx') == '0'){
							target.hide();
						}
						else if (idx === data.length - 1){
							container.find('a').eq(1).show(1000);
						}
					}
					else if (target.hasClass('next') && idx < data.length){
						img.attr('src', data[idx + 1].src);
						caption.text(data[idx +1].caption);
						
						img.attr('idx', idx + 1);
						if (idx === data.length){
							target.hide(1000);
						}
						else if (idx === 1){
							container.find('a').eq(0).show(1000);
						}
					}
				});
			},
			prevnextFocus : function(e){
				e.preventDefault();
			
				$(e.target).stop().animate({
					width: 140,
					opacity: .6
				}, 1400)
				$('div.content-wrapper-outer caption')
					.stop()
					.fadeOut(500)
			},
			prevnextBlur : function(e){
				e.preventDefault();
				$(e.target).stop().animate({
					width: 60,
					opacity: .2
				}, 800)
				$('div.content-wrapper-outer caption')
					.stop()
					.fadeIn(500)
			}
		}
	}

});